#include <u.h>
#include <libc.h>
#include "common.h"

void
message(char *fmt,...)
{
    va_list args;
    va_start(args,fmt);
	vfprint(2,fmt,args);
	fprint(2,"\n");
    va_end(args);
}

/*
 *  turn keyboard raw mode on
 */
void
raw(int ctl, int mode)
{
	if(mode)
		write(ctl, "rawon", 5);
	else
		write(ctl, "rawoff", 6);
}

void
kill(int pid)
{
	char buf[128];
	int fd;
	snprint(buf, sizeof(buf),"/proc/%d/ctl",pid);
	fd = open(buf,OWRITE);
	if(fd < 0){
		message("/proc/%d/ctl not open",pid);
		exits("open");
	}
	write(fd,"kill",4);
	close(fd);
}

