-- 2023-06-14 bugs in comment are fixed

-- fd is defined in api.lua as global variable

-- respose data of remote AT command
-- cmd name must be that of AT command
function resdata(s,cmdname)
	local t,h,dest1
	t = {byte(s,1,#s)}
	if dest then
		dest1 = gsub(dest,":","")
		assert(t[4] == 0x97 and substr(s,6,13) == hex2str(dest1),
		"# error:"..fmt("%02x",t[4])..","..dest)
		h = 16
	else
		assert(t[4] == 0x88, "# error"..substr(4,4))
		h = 6
	end
	assert(substr(s,h,h+1) == substr(cmdname,1,2), "# error in cmdname:"..cmdname)
	if t[h+2] ~= 0 then
		-- somthing weird. so assert is not used
		print("# error in cmd status "..fmt("%02x",t[h+2]))
		--[[
		0	OK
		1	error	--> Have you set ATDn to 2
		2	invalid command
		3	invalid parameter
		4	send failure	--> Cofirm association LED
		ref: api.txt
		--]]
	end
	return substr(s,h+3,#s-1)
end

function _AT(cmd)	-- return resdata
	-- cmd is "IS", "D2 5", etc
	--print("DBG -- _AT")
	local s,r,b
	incfid()
	frame = mkframe(cmd, dest)
	if p9.write(fd,frame) ~= #frame then
		print("# write error")
	end
	s = rdframe(fd)
	-- check the result. look CQpub p.37
	r = resdata(s,cmd)
	return r
end

--[[
on cons
_ATIS
--]]
function _ATIS()
	--print("DBG -- _ATIS")
	local n,s,r,b,v,d,vcc,time,out

	time = fmt("%d",os.time())
	v = _AT("%V")
	v = (byte(v,1,1)*256 + byte(v,2,2))*1200/1024 -- ref. CQpub p.172
	vcc = fmt("%1.3f",v/1000)
	r = _AT("IS")
	assert(#r ~= 0, "# no resdata") --> need some analog input pins
	h = str2hex(r)
	s = split(h)
	dmask = s[2]..s[3]
	amask = s[4]
	data = dmask .. " " .. amask
	n = 5
	if dmask == "0000" then
		data = data .. " 0000"
	else
		data = data .. " " .. s[5]..s[6]
		n = n + 2
	end
	b = tonumber(amask,16)
	for i=1,8 do
		if 0x01 & b ~= 0 then
			v = tonumber(s[n]..s[n+1],16)
			data = data .. fmt(" %5.3f",v/1023 * 1.2) -- look NOTE1 below
			n = n + 2
		end
		b= b>>1
	end
	out = time .. " " .. vcc .. " " .. data .."\n"
	p9.write(1,out)
	return out
end

function _xATIS()
	t = _ATIS()
	t = split(t)
	if tonumber(t[6]) < 0.9 then
		_AT("D2 4")
		os.exit(7)	-- the "7" is used in getdata.rc
	end
end


--[[	old	_ATIS()
Example
after setting
ATD1 2
ATD2 2
I got response data:
1681526906 3.158 01 00 00 06 00 03 03 BA
1681526906 	-- unix time
3.158	-- Vcc reported by XBee (AT%V command)
01		-- alway 01 (starting byte of ATIS data)
00 00 	-- digital channel mask (in this case,no digital input)
06		-- anaolog channel mask (D1 and D2 are masked)
00 03	-- analog data for D1 --> 0x03/1023.0 * 1.2 -- 0.0035V
03 BA	-- analog data for D2 --> 0x3ba/1023.0 * 1.2 -- 1.1190V

the actual voltage messured using tester(MS8268) was 1.172V
--]]


--[[	new _ATIS
Example
after setting
ATD1 2
ATD2 2
I got response data:

1681537216 3.168 0000 06 0000 0.004 1.180
1681537216	-- unix time
3.168 	-- Vcc reported by XBee (AT%V command)
0000	-- digital channel mask (in this case,no digital input)
06		-- anaolog channel mask (D1 and D2 are masked)
0000	-- digital data
0.004	-- analog data for D1 in unit of volt
1.180	-- analog data for D2 in unit of volt

the actual voltage messured using tester(MS8268) was 1.201
--]]

--[[
NOTE1: 1023 or 1024 ?
two different values are used in books in calculating volt from responce data,
even if in the same book!
CQpub p.29	--> 1023
CQpub p.66	--> 1024
the problem is due to ambiguity of the manual.
--]]